// D import file generated from 'derelict/sdl/image.d'
module derelict.sdl.image;
private 
{
    import derelict.util.loader;
    import derelict.util.exception;
    import derelict.util.compat;
    import derelict.sdl.sdl;
}
alias SDL_SetError IMG_SetError;
alias SDL_GetError IMG_GetError;
enum : Uint8
{
SDL_IMAGE_MAJOR_VERSION = 1,
SDL_IMAGE_MINOR_VERSION = 2,
SDL_IMAGE_PATCHLEVEL = 8,
}
void SDL_IMAGE_VERSION(SDL_version* X)
{
X.major = SDL_IMAGE_MAJOR_VERSION;
X.minor = SDL_IMAGE_MINOR_VERSION;
X.patch = SDL_IMAGE_PATCHLEVEL;
}
enum 
{
IMG_INIT_JPG = 1,
IMG_INIT_PNG = 2,
IMG_INIT_TIF = 4,
}
extern (C) 
{
    alias int function(int) da_IMG_Init;
    alias int function() da_IMG_Quit;
    alias CSDLVERPTR function() da_IMG_Linked_Version;
    alias SDL_Surface* function(SDL_RWops*, int, char*) da_IMG_LoadTyped_RW;
    alias SDL_Surface* function(in char*) da_IMG_Load;
    alias SDL_Surface* function(SDL_RWops*, int) da_IMG_Load_RW;
    alias int function(int) da_IMG_InvertAlpha;
    alias int function(SDL_RWops*) da_IMG_isBMP;
    alias int function(SDL_RWops*) da_IMG_isGIF;
    alias int function(SDL_RWops*) da_IMG_isJPG;
    alias int function(SDL_RWops*) da_IMG_isLBM;
    alias int function(SDL_RWops*) da_IMG_isPCX;
    alias int function(SDL_RWops*) da_IMG_isPNG;
    alias int function(SDL_RWops*) da_IMG_isPNM;
    alias int function(SDL_RWops*) da_IMG_isTIF;
    alias int function(SDL_RWops*) da_IMG_isXCF;
    alias int function(SDL_RWops*) da_IMG_isXPM;
    alias int function(SDL_RWops*) da_IMG_isXV;
    alias int function(SDL_RWops*) da_IMG_isICO;
    alias int function(SDL_RWops*) da_IMG_isCUR;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadBMP_RW;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadGIF_RW;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadJPG_RW;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadLBM_RW;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadPCX_RW;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadPNG_RW;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadPNM_RW;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadTGA_RW;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadTIF_RW;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadXCF_RW;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadXPM_RW;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadXV_RW;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadICO_RW;
    alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadCUR_RW;
    alias SDL_Surface* function(char**) da_IMG_ReadXPMFromArray;
}
mixin(gsharedString!() ~ "
da_IMG_Init IMG_Init;
da_IMG_Quit IMG_Quit;
da_IMG_Linked_Version IMG_Linked_Version;
da_IMG_LoadTyped_RW IMG_LoadTyped_RW;
da_IMG_Load IMG_Load;
da_IMG_Load_RW IMG_Load_RW;
da_IMG_InvertAlpha IMG_InvertAlpha;
da_IMG_isBMP IMG_isBMP;
da_IMG_isGIF IMG_isGIF;
da_IMG_isJPG IMG_isJPG;
da_IMG_isLBM IMG_isLBM;
da_IMG_isPCX IMG_isPCX;
da_IMG_isPNG IMG_isPNG;
da_IMG_isPNM IMG_isPNM;
da_IMG_isTIF IMG_isTIF;
da_IMG_isXCF IMG_isXCF;
da_IMG_isXPM IMG_isXPM;
da_IMG_isXV IMG_isXV;
da_IMG_isICO IMG_isICO;
da_IMG_isCUR IMG_isCUR;
da_IMG_LoadBMP_RW IMG_LoadBMP_RW;
da_IMG_LoadGIF_RW IMG_LoadGIF_RW;
da_IMG_LoadJPG_RW IMG_LoadJPG_RW;
da_IMG_LoadLBM_RW IMG_LoadLBM_RW;
da_IMG_LoadPCX_RW IMG_LoadPCX_RW;
da_IMG_LoadPNG_RW IMG_LoadPNG_RW;
da_IMG_LoadPNM_RW IMG_LoadPNM_RW;
da_IMG_LoadTGA_RW IMG_LoadTGA_RW;
da_IMG_LoadTIF_RW IMG_LoadTIF_RW;
da_IMG_LoadXCF_RW IMG_LoadXCF_RW;
da_IMG_LoadXPM_RW IMG_LoadXPM_RW;
da_IMG_LoadXV_RW IMG_LoadXV_RW;
da_IMG_LoadICO_RW IMG_LoadICO_RW;
da_IMG_LoadCUR_RW IMG_LoadCUR_RW;
da_IMG_ReadXPMFromArray IMG_ReadXPMFromArray;
");
class DerelictSDLImageLoader : SharedLibLoader
{
    public 
{
    this()
{
super("SDL_image.dll","libSDL_image.so, libSDL_image-1.2.so, libSDL_image-1.2.so.0","../Frameworks/SDL_image.framework/SDL_image, /Library/Frameworks/SDL_image.framework/SDL_image, /System/Library/Frameworks/SDL_image.framework/SDL_image");
}
    protected override void loadSymbols();


}
}
DerelictSDLImageLoader DerelictSDLImage;
static this();
